package me.Demon.DemonLevels.listener;

import me.Demon.DemonLevels.Main;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonLevels.data.PlayerData;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.scheduler.BukkitRunnable;

import java.math.BigInteger;

public class JoinEvent implements Listener {

    @EventHandler
    public void onJoin(PlayerJoinEvent e){
        Player p = e.getPlayer();
        String name = p.getName();
        String uuid = p.getUniqueId().toString();
        PlayerData playerData = Main.serverManage.getPlayerData(uuid); // 读取玩家的等级数据
        new BukkitRunnable() {
            @Override
            public void run() {
                FileConfiguration yml = Main.plugin.getConfig();
                int totalExp = yml.getInt("levelstats."+name+".totalExp");
                if(totalExp > playerData.getTotalExp().intValue()){
                    DLevelAPI.setTotalExp(p,new BigInteger(yml.getString("levelstats."+name+".totalExp")));
                    System.out.println("[调试 - 修正] 玩家 "+name+" 经验出现错误,已被纠正.");
                }
            }
        }.runTaskLater(Main.plugin,100L);
    }

    @EventHandler
    public void onQuit(PlayerQuitEvent e){
        // 当玩家离开服务器时保存等级数据
        Player p = e.getPlayer();
        String uuid = p.getUniqueId().toString();
        PlayerData playerData = Main.serverManage.getPlayerData(uuid); // 读取玩家的等级数据
        playerData.savePlayerData();
    }
}
