package me.Demon.DemonLevels.manage;

import me.Demon.DemonLevels.Main;
import me.Demon.DemonLevels.data.PlayerData;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.serverct.ersha.jd.Ha;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.UUID;

public class ServerManage {

    private HashMap<String,PlayerData> dataHashMap = new HashMap<>();
    private double expMultiplicity; // 当前经验倍率
    private long expMultipleTime;
    private boolean LinkDemonVipSystem = false; // 是否已关联 贵族系统

    public ServerManage(FileConfiguration yml){
        expMultipleTime = yml.getLong("ExpMultipleTime");
        if(expMultipleTime <= 0){
            expMultipleTime = System.currentTimeMillis() + (1000 * 60);
        }
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f倍率持续时间 §8> §6"+DemonAPI.LongToStringData(expMultipleTime,"yyyy年MM月dd日"));
        expMultiplicity = yml.getDouble("DoubleExp");
        if(expMultiplicity <= 0){
            expMultiplicity = 1.0;
        }
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f全服经验倍率 §8> §6"+(expMultiplicity*100)+"%");
        if(Bukkit.getPluginManager().getPlugin("DemonVipSystem") != null){
            LinkDemonVipSystem = true;
            DemonAPI.sendConsoleMessage("§f[§a!§f] §fDemonVipSystem §8> §6完成");
        }
    }

    public long getExpMultipleTime() {
        return expMultipleTime;
    }

    public boolean isExpMultipleTime(){
        if(System.currentTimeMillis() >= getExpMultipleTime()){
            return true;
        }
        return false;
    }

    public double getExpMultiplicity() {
        return expMultiplicity;
    }

    public void setExpMultiplicity(double expMultiplicity,long expMultipleTime) {
        this.expMultipleTime = expMultipleTime;
        this.expMultiplicity = expMultiplicity;
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("ExpMultipleTime",this.expMultipleTime);
        yml.set("DoubleExp",this.expMultiplicity);
        Main.plugin.saveConfig();
    }

    public boolean isLinkDemonVipSystem() {
        return LinkDemonVipSystem;
    }

    public PlayerData getPlayerData(String uuid){
        if(dataHashMap.get(uuid) == null){
            dataHashMap.put(uuid,new PlayerData(uuid));
        }
        return dataHashMap.get(uuid);
    }

    public HashMap<String, PlayerData> getDataHashMap() {
        return dataHashMap;
    }
}
