package me.Demon.DemonLevels.util;

import me.Demon.DemonLevels.Main;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;

import java.io.File;
import java.io.IOException;
import java.util.UUID;

public abstract class GameUtil {

    public static int convertInt(String string){
        try {
            return Integer.parseInt(string);
        } catch (NumberFormatException | ArrayIndexOutOfBoundsException e) {
            return 1;
        }
    }

    public static double convertDouble(String string){
        try {
            return Double.parseDouble(string);
        } catch (NumberFormatException | ArrayIndexOutOfBoundsException e) {
            return 1.0;
        }
    }

    public static String formatTime(long millis) {
        // 转换毫秒为秒
        long seconds = millis / 1000;

        // 计算天、小时和分钟
        long days = seconds / (24 * 3600);
        long hours = (seconds % (24 * 3600)) / 3600;
        long minutes = (seconds % 3600) / 60;

        // 判断时间长度的范围，并格式化输出
        if (days > 0) {
            return String.format("%d天%d小时", days, hours);
        } else if (hours > 0) {
            return String.format("%d小时%d分钟", hours, minutes);
        } else {
            return String.format("%d分钟", minutes);
        }
    }
}
